package com.yhy.module.core.service.boq;

import com.yhy.module.core.controller.admin.boq.vo.BoqDetailTreeRespVO;
import com.yhy.module.core.controller.admin.boq.vo.BoqDetailTreeSaveReqVO;

import javax.validation.Valid;
import java.util.List;

/**
 * 清单明细树 Service 接口
 *
 * @author yhy
 */
public interface BoqDetailTreeService {

    /**
     * 创建节点
     *
     * @param createReqVO 创建信息
     * @return 节点ID
     */
    Long createNode(@Valid BoqDetailTreeSaveReqVO createReqVO);

    /**
     * 更新节点
     *
     * @param updateReqVO 更新信息
     */
    void updateNode(@Valid BoqDetailTreeSaveReqVO updateReqVO);

    /**
     * 删除节点
     *
     * @param id 节点ID
     */
    void deleteNode(Long id);

    /**
     * 获取节点详情
     *
     * @param id 节点ID
     * @return 节点信息
     */
    BoqDetailTreeRespVO getNode(Long id);

    /**
     * 获取树形结构
     *
     * @param boqSubItemId 清单子项ID
     * @return 树形结构
     */
    List<BoqDetailTreeRespVO> getTree(Long boqSubItemId);

    /**
     * 获取列表
     *
     * @param boqSubItemId 清单子项ID
     * @return 列表
     */
    List<BoqDetailTreeRespVO> getList(Long boqSubItemId);

    /**
     * 交换排序
     *
     * @param nodeId1 节点ID1
     * @param nodeId2 节点ID2
     */
    void swapSort(Long nodeId1, Long nodeId2);
}
